
| -----------------------------------------------------------------------------
| Sub:PBDeclareOuters
| -----------------------------------------------------------------------------
	Sub PBDeclareOuters

		| Debug call stack
		PBCALLINGSUB
		PBCALLINGINDEX
		PBPUSHCALL

		PBDEBUGINIT Entered
		
		/declare PBIniDeclares					string		outer
		/varset PBIniDeclares	PBVerbose|PBPetAttackDist|PBPetAttackDly|PBPetUseLOS|PBXTSlot|PBAutoConOn|PBAutoConDly|PBAutoConCtLeash
		/varset PBIniDeclares	${PBIniDeclares}|PBMobLevelCkOn|PBMobLevelRange|PBCkRadarOn|PBCkRadarMaxRadius|PBCkRadarMaxMobs|PBRescueMasterOn
		/varset PBIniDeclares	${PBIniDeclares}|PBRescueMasterPctHPs|PBRescueGrpMembersOn|PBRescueImmed|PBRescueImmedPctHPs|PBRescueSecond|PBRescueSecondPctHPs
		/varset PBIniDeclares	${PBIniDeclares}|PBRescueThird|PBRescueThirdPctHPs|PBRescueLast|PBRescueLastPctHPs|PBRescueNever|PBRescueMercsOn|PBRescueMercs|PBRescueMercsPctHPs

		| If we add more Ini vars, also list them. A Help ini per var is created automagically. Do not add a | pipe to the very end of list.
		|/varset PBIniDeclares	${PBIniDeclares}|

		/declare PBPetMode						string		outer		NULL
				
		| Lots of blah for the user to learn.
		/declare PBVerboseHlp					string		outer		"Change to 0 in order to reduce messages after you are comfortable with PetBot."
		/declare PBVerbose						int			outer		1
		
		| Is it a safe zone?
		/declare PBisDMZ						int			outer		0
		
		| Current zone name
		/declare PBZoneName						string		outer		NULL
		/declare PBZoneID						int			outer		0
		
		| Last zone we were in
		/declare PBLastZoneID					int			outer		NULL
		
		| The distance the pet will travel to attack mobs until they are out of hps
		/declare PBPetAttackDistHlp				string		outer		"The distance PetBot will streak forward to slaughter mobs. If you are roaming, you may wish to keep it to 75-100, but if stationary and just want to mow down everything, 200 is a bold setting. Perhaps more."
		/declare PBPetAttackDist				int			outer		100
		
		| The delay between choosing a new hapless victim
		/declare PBPetAttackDlyHlp				string		outer		"How long PetBot will wait before attacking a new mob. Note: indicate seconds with s. E.g. 5s. Minutes m. Hours h. Otherwise it will use milliseconds."
		/declare PBPetAttackDly					string		outer		5s
		
		| Pet use LOS?
		/declare PBPetUseLOSHlp					string		outer		"Should PetBot wait until it has victims in line of sight?"
		/declare PBPetUseLOS					int			outer		1
		
		| Which XTarget slot to watch for aggro
		/declare PBXTSlotHlp					string		outer		"The XTarget slot petbot will watch to choose the next target to attack if engaged in combat with multiple mobs."
		/declare PBXTSlot						int			outer		1
		
		| If a mob is not ignored, and may be hostile, consider it.
		/declare PBAutoConOnHlp					string		outer		"Should PetBot /consider before attacking, if its deemed a worthy meal?"
		/declare PBAutoConOn					int			outer		0
		
		| The delay between subsequent considers.
		/declare PBAutoConDlyHlp				string		outer		"The delay between subsequent considers. This setting keeps the pet in line while evaluating the situation."
		/declare PBAutoConDly					string		outer		7s
		
		| If n mobs considered in a row are not-hostile, then /pbpause
		/declare PBAutoConCtLeashHlp			string		outer		"The pet will automatically leash if it finds n non-hostile mobs in a row."
		/declare PBAutoConCtLeash				int			outer		3
		| Internal counter var
		/declare PBAutoConCtr					int			outer		0

		| Each zone has a list of mobs to attack
		/declare PBZoneAttackListHlp			string		outer		"Mobs, by zone, your pet will automatically attack. Use | pipe delimiter."
		/declare PBZoneAttackList				string		outer		NULL

		| Each zone has a list of mobs to ignore
		/declare PBZoneIgnoreListHlp			string		outer		"Mobs, by zone, your pet will not automatically attack. Petbot will still engage them if they aggro. Use | pipe delimiter."
		/declare PBZoneIgnoreList				string		outer		NULL

		| Should we only attack mobs within a given level range?
		/declare PBMobLevelCkOnHlp				string		outer		"Should we only attack mobs within a given level range?"
		/declare PBMobLevelCkOn					int			outer		1
		
		| Lowest|Highest level
		/declare PBMobLevelRangeHlp				string		outer		"Lowest level|Highest level. Use | pipe delimiter. By default lowest is 0, highest is your level + 2."
		/declare PBMobLevelRange				string		outer		1|${Int[${Math.Calc[${Me.Level}+2]}]}

		| Should we look for the mob on a list? Internal use based on /pbbite /pbwild /pbwag
		/declare PBUseAttackListOn				int			outer		0
		/declare PBUseIgnoreListOn				int			outer		0

		| Should we check radar for potential adds?
		/declare PBCkRadarOnHlp					string		outer		"Look for any potential adds or high level mobs near the mob?"
		/declare PBCkRadarOn					int			outer		0

		| How many mobs is it ok to aggro if we attack?
		/declare PBCkRadarMaxRadiusHlp			string		outer		"The distance around a mob the radar looks."
		/declare PBCkRadarMaxRadius				int			outer		25

		| How many mobs is it ok to aggro if we attack?
		/declare PBCkRadarMaxMobsHlp			string		outer		"How many adds are acceptable?"
		/declare PBCkRadarMaxMobs				int			outer		2

		/declare PBRescueMasterOnHlp			string		outer		"Should petbot be concerned about your health and intervene if you are directly attacked?"
		/declare PBRescueMasterOn				int			outer		1
		/declare PBRescueMasterPctHPsHlp		string		outer		"Your PctHPs before petbot engages."
		/declare PBRescueMasterPctHPs			int			outer		90

		/declare PBRescueGrpMembersOnHlp		string		outer		"Should petbot intervene if group members are attacked?"
		/declare PBRescueGrpMembersOn			int			outer		0
		
		/declare PBRescueImmedHlp				string		outer		"The classes petbot should protect first."
		/declare PBRescueImmed					string		outer		cleric|druid|shaman
		/declare PBRescueImmedPctHPsHlp			string		outer		"PctHPs before petbot engages."
		/declare PBRescueImmedPctHPs			int			outer		85
		
		/declare PBRescueSecondHlp				string		outer		"The classes petbot should protect second."
		/declare PBRescueSecond					string		outer		enchanter|wizard|magician
		/declare PBRescueSecondPctHPsHlp		string		outer		"PctHPs before petbot engages."
		/declare PBRescueSecondPctHPs			int			outer		85

		/declare PBRescueThirdHlp				string		outer		"The classes petbot should protect third."
		/declare PBRescueThird					string		outer		berserker|ranger|beastmaster
		/declare PBRescueThirdPctHPsHlp			string		outer		"PctHPs before petbot engages."
		/declare PBRescueThirdPctHPs			int			outer		45

		/declare PBRescueLastHlp				string		outer		"The classes petbot should protect last."
		/declare PBRescueLast					string		outer		monk|rogue
		/declare PBRescueLastPctHPsHlp			string		outer		"PctHPs before petbot engages."
		/declare PBRescueLastPctHPs				int			outer		25

		/declare PBRescueNeverHlp				string		outer		"Petbot cares not for these classes. They can die for all petbot cares."
		/declare PBRescueNever					string		outer		warrior|shadowknight|paladin
		
		/declare PBRescueMercsOnHlp				string		outer		"Should petbot try to save mercenaries?"
		/declare PBRescueMercsOn				int			outer		1
		/declare PBRescueMercsHlp				string		outer		"Which mercenary classes should petbot try to save?"
		/declare PBRescueMercs					string		outer		cleric|wizard
		/declare PBRescueMercsPctHPsHlp			string		outer		"PctHPs before petbot tries to save?"
		/declare PBRescueMercsPctHPs			int			outer		50

		| When did we last move. Will /pbleash when idle. Internal variables.
		/declare PBLastSitStand					bool		outer		${Me.Sitting}
		/declare PBLastMoveHeading				float		outer		0.0
		/declare PBLastMoveX					float		outer		0.0
		/declare PBLastMoveY					float		outer		0.0
		/declare PBLastMoveZ					float		outer		0.0
		/declare PBLastMoveTime					int			outer		${EverQuest.Running}
		/declare PBTimeSinceMove				int			outer		0
		
		/declare PBLeashWhenIdleTimeHlp			string		outer		"How long should petbot continue its rampage if you go afk?"
		/declare PBLeashWhenIdleTime			string		outer		15m
		/declare PBLeashWhenIdleTimerOn			timer		outer		0

		PBDEBUGINIT Exit

		PBPOPCALL
		
	/return

| -----------------------------------------------------------------------------
| Sub:PBInit
| -----------------------------------------------------------------------------
	Sub PBInit

		| Debug call stack
		PBCALLINGSUB
		PBCALLINGINDEX
		PBPUSHCALL

		PBDEBUGINIT Entered

		/declare PBParams		int		local	0
		/declare PBDParam		string	local
		/declare PBDParamHlp	string	local
		/declare i				int		local	0
		
		/call PBDeclareOuters
		/call PBSetZoneName
		
		| Comparing floats not working right. Using strings. /boggles
		/if (!${Ini["${PBIni}","PetBot","PBVersion"].Length}) {
			/ini "${PBIni}" "PetBot" "PBVersion" "${PetBotVersion}"
			/ini "${PBIni}" "PetBot" "PBVersionDate" ""${PetBotVersionDate}""
			/varset PBVersion ${PetBotVersion}
			/varset PBVersionDate ${PetBotVersionDate}
		} else {
			/varset PBVersion ${Ini["${PBIni}","PetBot","PBVersion"]}
			/varset PBVersionDate   ${Ini["${PBIni}","PetBot","PBVersionDate"]}
			/if (${Float[${PetBotVersion}]}>${Float[${PBVersion}]}) {
				/echo Please note: PetBot is now at version ${PetBotVersion}, released ${PetBotVersionDate}. Please check the Update at Redguides.com for any changes. This notice will not be displayed again.
				/ini "${PBIni}" "PetBot" "PBVersion" "${PetBotVersion}"
				/ini "${PBIni}" "PetBot" "PBVersionDate" ""${PetBotVersionDate}""
				/delay 10s
			}
		}

		/varcalc PBParams	${PBIniDeclares.Count[|]}+1		
		/for i 1 to ${PBParams}
			/if (${Defined[${PBIniDeclares.Arg[${i},|]}]}) {
				/varset PBDParam "${${PBIniDeclares.Arg[${i},|]}}"
				
				/if (!${Ini["${PBIni}","PetBot","${PBIniDeclares.Arg[${i},|]}"].Length}) {
					/ini "${PBIni}" "PetBot" "${PBIniDeclares.Arg[${i},|]}" "${PBDParam}"
				} else {
					/varset ${PBIniDeclares.Arg[${i},|]} ${Ini["${PBIni}","PetBot","${PBIniDeclares.Arg[${i},|]}"]}
				}
			} else {
				/echo Could not find variable ${PBIniDeclares.Arg[${i},|]}
			}
		/next i

		/for i 1 to ${PBParams}
			/if (${Defined[${PBIniDeclares.Arg[${i},|]}Hlp]}) {
				/varset PBDParamHlp "${${PBIniDeclares.Arg[${i},|]}Hlp}"
				/ini "${PBIni}" "Help" "${PBIniDeclares.Arg[${i},|]}Hlp" "${PBDParamHlp}"
		/next i

		| Post-declare internal variables
		/call PBStripExtraPipes ${PBMobLevelRange}
		/varset PBMobLevelRange ${Macro.Return}

		| Internal var
		/declare PBMobLowestLevel				int			outer		${PBMobLevelRange.Arg[1,|]}
		| Internally if the 2nd arg is 0, then we set it to 999
		/declare PBMobHighestLevel				int			outer		${If[!${PBMobLevelRange.Arg[2,|]},999,${PBMobLevelRange.Arg[2,|]}]}

		| Thwart the rascals.
		/if (${PBMobLowestLevel}<0) /varset PBMobLowestLevel 0
		/if (${PBMobLowestLevel}>${PBMobHighestLevel}) {
			/varset PBMobLowestLevel 0
			/varset PBMobHighestLevel 999
		}
		
		PBDEBUGINIT Exit
		
		PBPOPCALL
		
	/return	

| -----------------------------------------------------------------------------
| Sub:PBDelay
| -----------------------------------------------------------------------------
	Sub PBDelay(timer PBPauseDurationOn)
		/while (${PBPauseDurationOn}) {
			/doevents
			/if (${PBEventFlag}) {
				/varset PBEventFlag 0
				/return
			}
			/delay 2
		}
	/return

| -----------------------------------------------------------------------------
| Sub:Bind_PBPause
| -----------------------------------------------------------------------------
	Sub Bind_PBPause(int EventFlag)

		| Debug call stack
		PBCALLINGSUB
		PBCALLINGINDEX
		PBPUSHCALL
	
		/if (${PBVerbose}) {
			/echo \ayLeashing! \aoPet snapping madly and awaiting /pbunleash or /pbresume. /pbquit to end.
		} else {
			/echo \ayLeashing!
		}
		/varset PBPauseOn 1
		/varset PBEventFlag ${EventFlag}
		
		PBPOPCALL
		
	/return

| -----------------------------------------------------------------------------
| Sub:Bind_PBResume
| -----------------------------------------------------------------------------
	Sub Bind_PBResume
		/if (${PBVerbose}) {
			/echo \ayUnleashing! \aoTo wrangle PetBot, use /pbleash or /pbpause. /pbquit to make it all end.
		} else {
			/echo \ayUnleashing!
		}
		/varset PBPauseOn 0
		/varset PBPauseAlertOn 0
	/return

| -----------------------------------------------------------------------------
| Sub:Bind_PBQuit
| -----------------------------------------------------------------------------
	Sub Bind_PBQuit
		/endmacro
	/return

| -----------------------------------------------------------------------------
| Sub:Bind_PBReload
| -----------------------------------------------------------------------------
	Sub Bind_PBReload
		/mac ${PBMac} ${PBPetMode}
	/return

| -----------------------------------------------------------------------------
| Sub:Bind_PBVerbose
| -----------------------------------------------------------------------------
	Sub Bind_PBVerbose(string VerboseSetting)
	
		/if (!${VerboseSetting.Length}) {
	
			/if (${PBVerbose}) {
				/varset PBVerbose 0
			} else {
				/varset PBVerbose 1
			}
			
		} else /if (${Select[${VerboseSetting},1,on]}) {
			/varset PBVerbose 1
		} else /if (${Select[${VerboseSetting},0,off]}) {
			/varset PBVerbose 0
		}
		
		/ini "${PBIni}" "PetBot" "PBVerbose" "${PBVerbose}"
		
	/return

| -----------------------------------------------------------------------------
| Sub:Bind_PBDistance
| -----------------------------------------------------------------------------
	Sub Bind_PBDistance(string DistanceSetting)
	
		/declare PBForceInt		int		local	0
	
		/if (${DistanceSetting.Length}) {
			/varset PBForceInt	${Int[${DistanceSetting}]}
			/if (${PBForceInt}>=0 && ${PBForceInt}<=250) {
				/varset PBPetAttackDist ${PBForceInt}		
				/ini "${PBIni}" "PetBot" "PBPetAttackDist" "${PBPetAttackDist}"
			}	
		}

		/echo Pet Attack Distance: ${PBPetAttackDist}

	/return

| -----------------------------------------------------------------------------
| Sub:Bind_PBMode
| -----------------------------------------------------------------------------
	Sub Bind_PBMode(string NewMode)
	
		/if (!${NewMode.Length}) {
			/if (${Select[${PBPetMode},wild,free]}) {
				/echo \ayPetBot is in \arWild and Free\ay mode.
			} else {
				/echo \ayPetBot is in \ar${PBPetMode}\ay mode.
			}
			/return
		}
	
		/call PBUCase "${NewMode}"
		/varset PBPetMode ${Macro.Return}
	
		/if (!${Select[${PBPetMode},bite,wild,free,wag]}) {
			/varset PBPetMode Wild
			/echo
			/echo \aoValid modes: [bite] now and wag later, be [wild] and [free] to make own choices, or [wag] now and bite later. Default: Wild
			/echo		
		}
		
		/if (${Select[${PBPetMode},wild,free]}) {
			/varset PBPetMode Wild
			/echo \awPetBot mode: \ayWild and Free
		} else {
			/echo \awPetBot mode: \ay${PBPetMode}
		}
		
		/if (${PBPetMode.Equal[Wild]}) {
			/if (${PBVerbose}) {
				/echo PetBot will wait for you to /pbattack "name in quotes" or target, before it goes after those mobs. Use /pbignore to tell PetBot to never attack mobs you deem unworthy. Once told, PetBot won't have to be told again unless you change your mind. Your choices are remembered by zone.
				/echo
			}
			/varset PBPauseOn 1
			/varset PBUseIgnoreListOn 1
			/varset PBUseAttackListOn 1
		}
		/if (${PBPetMode.Equal[Wag]}) {
			/if (${PBVerbose}) {
				/echo PetBot will wait until told to /pbattack "name in quotes" or target. PetBot will ignore the ignore list. Starting paused. 
				/echo
			}
			/varset PBPauseOn 1
			/varset PBUseAttackListOn 1
			/varset PBUseIgnoreListOn 0
		}
		/if (${PBPetMode.Equal[Bite]}) {
			/if (${PBVerbose}) {
				/echo Your pet will attack everything unless told to /pbignore "name in quotes" or target. PetBot will ignore the attack list. This is the most dangerous mode! Starting paused. You've been warned. 
				/echo
			}
			/varset PBPauseOn 1
			/varset PBUseIgnoreListOn 1
			/varset PBUseAttackListOn 0
		}

	/return

| -----------------------------------------------------------------------------
| Sub:Bind_PBBite
| -----------------------------------------------------------------------------
	Sub Bind_PBBite
	
		/echo \ayPetBot is in \arBite\ay mode!
		/if (${PBVerbose}) {
			/echo Your pet will attack everything unless told to /pbignore "name in quotes" or target. PetBot will ignore the attack list. This is the most dangerous mode! Starting paused. You've been warned. 
			/echo
		}
		/varset PBPetMode Bite
		/call Bind_PBPause
		/varset PBUseIgnoreListOn 1
		/varset PBUseAttackListOn 0
		
	/return

| -----------------------------------------------------------------------------
| Sub:Bind_PBWag
| -----------------------------------------------------------------------------
	Sub Bind_PBWag
	
		/echo \ayPetBot is in \arWag\ay mode!
		/if (${PBVerbose}) {
			/echo PetBot will attack anything you've placed on the attack list. It will not attack a target until /pbattack "name in quotes" or target. Starting paused.
			/echo
		}
		/varset PBPetMode Wag
		/call Bind_PBPause
		/varset PBUseIgnoreListOn 0
		/varset PBUseAttackListOn 1
		
	/return

| -----------------------------------------------------------------------------
| Sub:Bind_PBWild
| -----------------------------------------------------------------------------
	Sub Bind_PBWild
	
		/echo \ayPetBot is in \arWild and Free\ay mode!
		/if (${PBVerbose}) {
			/echo PetBot will wait for you to /pbattack "name in quotes" or target, before it goes after those mobs. Use /pbignore to tell PetBot to never attack mobs you deem unworthy. Once told, PetBot won't have to be told again unless you change your mind. Your choices are remembered by zone. Starting paused.
			/echo
		}
		/varset PBPetMode Wild
		/call Bind_PBPause
		/varset PBUseIgnoreListOn 1
		/varset PBUseAttackListOn 1
		
	/return

| -----------------------------------------------------------------------------
| Sub:Bind_PBMobs
| -----------------------------------------------------------------------------
	Sub Bind_PBMobs
		/call PBZoneInformation
	/return

| -----------------------------------------------------------------------------
| Sub:Bind_PBSettings
| -----------------------------------------------------------------------------
	Sub Bind_PBSettings
	
		/call PBListSettings		
		/call PBZoneInformation
		/call PBListSettingsDetails

	/return

| -----------------------------------------------------------------------------
| Sub:Bind_PBAddToAttackList
| -----------------------------------------------------------------------------
	Sub Bind_PBAddToAttackList(string MobName)
	
		/if (${MobName.Length}) {
			/echo Adding ${MobName} to zone attack list.
			/call PBAddToList Attack "${MobName}"
			/call PBRemoveFromList Ignore "${MobName}"
			| User may have a target as well as provide parameter. Parameter has priority, so we return.
			/return
		}
		
		/if (${Target.ID}) {
			/echo Adding your target ${Target.CleanName} to attack list.
			/call PBAddToList Attack "${Target.CleanName}"
			/call PBRemoveFromList Ignore "${Target.CleanName}"
			/return
		}
		
		/echo Use /pbattack or /pbkill "name in quotes", or while targeting a mob.
		
	/return

| -----------------------------------------------------------------------------
| Sub:Bind_PBAddToIgnoreList
| -----------------------------------------------------------------------------
	Sub Bind_PBAddToIgnoreList(string MobName)
	
		/if (${MobName.Length}) {
			/echo Adding ${MobName} to zone ignore list.
			/call PBAddToList Ignore "${MobName}"
			/call PBRemoveFromList Attack "${MobName}"		
			| User may have a target as well as provide parameter. Parameter has priority, so we return.
			/return
		}
		
		/if (${Target.ID}) {
			/echo Adding your target ${Target.CleanName} to ignore list.
			/call PBAddToList Ignore "${Target.CleanName}"
			/call PBRemoveFromList Attack "${Target.CleanName}"
			/return
		}
		
		/echo Use /pbignore "name in quotes", or while targeting a mob.
		
	/return


| -----------------------------------------------------------------------------
| Sub:Bind_PBRemoveFromBothLists
| -----------------------------------------------------------------------------
	Sub Bind_PBRemoveFromBothLists(string MobName)
	
		/if (${MobName.Length}) {
			/echo Removing ${MobName} from zone list.
			/call PBRemoveFromList Attack "${MobName}"
			/call PBRemoveFromList Ignore "${MobName}"
			/return
		}
		
		/if (${Target.ID}) {
				/echo Removing your target ${Target.CleanName} from zone list.
				/call PBRemoveFromList Attack "${Target.CleanName}"
				/call PBRemoveFromList Ignore "${Target.CleanName}"
				/return
		}
		
		Use /pbremove "name in quotes", or while targeting a mob.
		
	/return

| -----------------------------------------------------------------------------
| Sub:PBRemoveFromList
| -----------------------------------------------------------------------------
	Sub PBRemoveFromList(string PBList, string MobName)

		/declare PBInList	int		local	0

		/call PBUCase ${PBList}
		/varset PBList ${Macro.Return}		
		
		| Check whether the mob is in the list already.
		/call PBCheckList ${PBList} "${MobName}"
		/varset PBInList ${Macro.Return}

		/if (${PBInList}) {
			| In case the user has been tinkering, let's make sure we surround with pipes. We strip dupes later.
			/varset PBZone${PBList}List |${PBZone${PBList}List.Replace[|${MobName}|,|]}|
	
			/call PBStripExtraPipes "${PBZone${PBList}List}"
			/varset PBZone${PBList}List ${Macro.Return}

			/if (!${PBZone${PBList}List.Length} || ${PBZone${PBList}List.Equal[|]} || ${PBZone${PBList}List.Equal[|NULL|]}) /varset PBZone${PBList}List NULL
		
			/ini "${PBIni}" "${PBZoneName}" "PBZone${PBList}List" "${PBZone${PBList}List}"
		}
		
	/return

| -----------------------------------------------------------------------------
| Sub:PBAddToList
| -----------------------------------------------------------------------------
	Sub PBAddToList(string PBList, string MobName)
	
		/declare PBInList		int		local	0
	
		/call PBUCase ${PBList}
		/varset PBList ${Macro.Return}
		
		| Check whether the mob is in the list already.
		/call PBCheckList ${PBList} "${MobName}"
		/varset PBInList ${Macro.Return}

		/if (!${PBInList}) {
			/if (${PBZone${PBList}List.Equal[null]} || ${PBZone${PBList}List.Equal[|null|]}) /varset PBZone${PBList}List
			
			/varset PBZone${PBList}List ${PBZone${PBList}List}|${MobName}|
						
			| Quotes needed here
			/call PBStripExtraPipes "${PBZone${PBList}List}"
			/varset PBZone${PBList}List ${Macro.Return}
			
			/ini "${PBIni}" "${PBZoneName}" "PBZone${PBList}List" "${PBZone${PBList}List}"			
		}

	/return

| -----------------------------------------------------------------------------
| Sub:PBCheckList
| -----------------------------------------------------------------------------
	Sub PBCheckList(string PBList, string MobName)	
	/return ${If[${PBZone${PBList}List.Find[|${MobName}|]},1,0]}

| -----------------------------------------------------------------------------
| Sub:PBListSettings
| -----------------------------------------------------------------------------
	Sub PBListSettings

		/declare PBParams		int		local	0
		/declare i				int		local	0

		/echo
		/echo \awPetBot Version ${PBVersion}, released upon this world ${PBVersionDate}.
		/echo \arPetBot will bring ruin upon this land.
		/echo
		
		/varcalc PBParams	${PBIniDeclares.Count[|]}+1		
		/for i 1 to ${PBParams}
			/echo ${PBIniDeclares.Arg[${i},|]}=${${PBIniDeclares.Arg[${i},|]}}
		/next i
		/echo
		
	/return	

| -----------------------------------------------------------------------------
| Sub:PBZoneInformation
| -----------------------------------------------------------------------------
	Sub PBZoneInformation

		/declare PBReadableList		string		local		NULL
		/declare i					int			local		0
		/declare PBListLength		int			local		0

		/echo
		/if (${PBVerbose}) {
			/echo \awYou are currently in zone ${Zone.Name} which you will find [\ay${PBZoneName}\aw] in your Ini. The attack and ignore lists for this zone are found there.
		} else {
			/echo \awPBZoneName: [${PBZoneName}]
		}
		/echo
		/if (${PBVerbose}) {
			/echo \ayMobs PetBot will seek and destroy:
		} else {
			/echo \ayPBZoneAttackList:
		}
		
		/if (${PBZoneAttackList.Equal[NULL]} || ${PBZoneAttackList.Equal[|NULL|]}) {
			/echo None
		} else {		
			| List begins and ends with a pipe.
			/varset PBReadableList ${PBZoneAttackList.Right[-1]}
			/varset PBReadableList ${PBReadableList.Left[-1]}
			/varset PBReadableList ${PBReadableList.Replace[|,, ]}
			/echo ${PBReadableList}
		}
		
		/echo
		/if (${PBVerbose}) {
			/echo \ayMobs unworthy of PetBot's attention:
		} else {
			/echo \ayPBZoneIgnoreList:
		}
		
		/if (${PBZoneIgnoreList.Equal[NULL]} || ${PBZoneIgnoreList.Equal[|NULL|]}) {
			/echo None
		} else {		
			| List begins and ends with a pipe.
			/varset PBReadableList ${PBZoneIgnoreList.Right[-1]}
			/varset PBReadableList ${PBReadableList.Left[-1]}
			/varset PBReadableList ${PBReadableList.Replace[|,, ]}
			/echo ${PBReadableList}
		}

		/echo

	/return
	
| -----------------------------------------------------------------------------
| Sub:PBListSettingsDetails
|
| Interpret settings. Summary of how petbot should behave given the settings.
| -----------------------------------------------------------------------------
	Sub PBListSettingsDetails
		
		| what do bite, wag, wild, free do
		| radar
		| consider
		| automatic behaviors
		| protection of master
		| protection of other classes
		| protection of mercs
		
	/return

| -----------------------------------------------------------------------------
| Sub:PBLoadZone
| -----------------------------------------------------------------------------
	Sub PBLoadZone
		
		| Debug call stack
		PBCALLINGSUB
		PBCALLINGINDEX
		PBPUSHCALL
		
		PBDEBUGINIT Entered
		
		/if (!${PBisDMZ}) {
			/if (!${Ini["${PBIni}","${PBZoneName}","PBZoneAttackList"].Length}) {
				/ini "${PBIni}" "${PBZoneName}" "PBZoneAttackList" "${PBZoneAttackList}"
				/varset PBZoneAttackList
			} else {
				/varset PBZoneAttackList ${Ini["${PBIni}","${PBZoneName}","PBZoneAttackList"]}
				/varset PBZoneAttackList |${PBZoneAttackList}|
				/call PBStripExtraPipes "${PBZoneAttackList}"
				/varset PBZoneAttackList ${Macro.Return}
			}
			
			/if (!${Ini["${PBIni}","${PBZoneName}","PBZoneIgnoreList"].Length}) {
				/ini "${PBIni}" "${PBZoneName}" "PBZoneIgnoreList" "${PBZoneIgnoreList}"
				/varset PBZoneIgnoreList
			} else {
				/varset PBZoneIgnoreList ${Ini["${PBIni}","${PBZoneName}","PBZoneIgnoreList"]}
				/varset PBZoneIgnoreList |${PBZoneIgnoreList}|
				/call PBStripExtraPipes "${PBZoneIgnoreList}"
				/varset PBZoneIgnoreList ${Macro.Return}
			}
		} else {
			/varset PBZoneAttackList
			/varset PBZoneIgnoreList
		}

		PBDEBUGINIT Exit

		PBPOPCALL

	/return

| -----------------------------------------------------------------------------
| Sub:PBGetDMZ
| -----------------------------------------------------------------------------
	Sub PBGetDMZ

		| We don't want to try to be attacking npcs in these places: GH GL PoK PoT Abysmal
        /if (${Select[${Zone.ID},202,203,279,344,345]}) {
            /varset PBisDMZ 1
        } else {
            /varset PBisDMZ 0
        }
		
	/return
	
| ---------------------------------------------------------------------------
| Sub:PBSetZoneName
| ---------------------------------------------------------------------------
	Sub PBSetZoneName

		| Directly from KA12
		/if (${Zone.Name.Find[,]} || ${Zone.Name.Find[']}) {
			/varset PBZoneName ${Zone.ShortName}${If[${Me.InInstance},_I,]}
		} else {
			/varset PBZoneName ${Zone}${If[${Me.InInstance},_I,]}
		}
		
	/return

| ----------------------------------------------------------------------------
| SUB: Event Zoned
|
| ZoneText is used to make decisions elsewhere. It is not the same as Zone.Name
|
| We can tell if we started to zone by looking at ..., and when we enter
| by the ZoneText. When we startup, ZoneText will be empty.
| ----------------------------------------------------------------------------
    Sub Event_PBZoned(Message, string ZoneText)
        /if (${Message.Find[Drunken Monkey]} || ${Message.Find[effects]}) /return

        /while (!${Me.ID} || !${Zone.ID}) {
            /delay 10
        }
		
        /if (${PBLastZoneID}!=${Zone.ID}) {
            /if (${Zone.Name.Find[,]} || ${Zone.Name.Find[']}) {
                /varset PBZoneName ${Zone.ShortName}${If[${Me.InInstance},_I,]}
            } else {
                /varset PBZoneName ${Zone}${If[${Me.InInstance},_I,]}
            }
        }
		
        /varset PBLastZoneID ${Zone.ID}
				
    /return
