
| -----------------------------------------------------------------------------
| Sub:PBBootInit
| -----------------------------------------------------------------------------
	Sub PBBootInit

		| Major revision increase by 1
		/declare PetBotMajorVersion				string		outer		1
		| Bug fixes increase by 1. New functionality 10
		/declare PetBotMinorVersion				string		outer		00
		/declare PetBotVersion					string		outer		${PetBotMajorVersion}.${PetBotMinorVersion}
		
		/declare PetBotVersionDate				string		outer		"July 5th, 2021"
		/declare PBBlameAuthor					string		outer		AmericanNero
		
		| Vars we use to load from Ini for comparison
		/declare PBVersion						string		outer		NULL
		/declare PBVersionDate					string		outer		NULL
	
		| ini filename. If we end up in our own subdir, then it should be petbot\petbot.ini
		/declare PBIni							string		outer		petbot\petbot.ini
		/declare PBMac							string		outer		petbot\petbot.mac
		
		/declare PBBootTime						int			outer		${EverQuest.Running}

		| Debug
		/declare PBDebug						int			outer		0
		/declare PBDebugAllOn					int			outer		0
		/declare PBDebugLogging					int			outer		0

		/declare PBDebugSectionList				string		outer		All,Hunt,Init,Main,Target

		/declare PBDebugHunt					int			outer		0
		/declare PBDebugInit					int			outer		0
		/declare PBDebugMain					int			outer		0
		/declare PBDebugTarget					int			outer		0
	
		| Pause vars
		/declare PBPauseOn						int			outer		0
		/declare PBPauseAlert 					string		outer		1m
		/declare PBPauseAlertOn					timer		outer		0
		/declare PBEventFlag					int			outer		0

		| In seconds. 1800=30m
		/declare PBAFKMaximumTime				string		outer		1800

		| Target
		/declare PBTargetID						int			outer		0
		/declare PBTargetName					string		outer
		
	/return
